/** The AST node for the 'boolean' type. */

package AST;

import SymbolTable.*;
import IL.*;
import Helpers.*;

public class BooleanType extends Type {
    // Constructor
    public BooleanType(int ln) {
	super(ln);
    }


    // AST printing
    public String toString(String indent) {
	return "boolean";
    }


    // Typechecking operations

    /** Check that this type is a legal type, and return the
     * corresponding resolved type to use during typechecking. */
    public ResolvedType resolve(SymbolTable st)
		throws TypecheckCompilerException {
	return resolvedType();
    }

    /** Return the resolved version of this type, after typechecking. */
    public ResolvedType resolvedType() {
	return ResolvedType.booleanType();
    }


    // Lowering operations

    /** Return the lowered version of this type */
    public ILType lower() {
	return ResolvedType.booleanType().lower();
    }
}
