/** The AST node for the 'int' type. */

package AST;

import SymbolTable.*;
import IL.*;
import Helpers.*;

public class IntType extends Type {
    // Constructor
    public IntType(int ln) {
	super(ln);
    }


    // AST printing
    public String toString(String indent) {
	return "int";
    }


    // Typechecking operations

    /** Check that this type is a legal type, and return the
     * corresponding resolved type to use during typechecking. */
    public ResolvedType resolve(SymbolTable st)
		throws TypecheckCompilerException {
	return resolvedType();
    }

    /** Return the resolved version of this type, after typechecking. */
    public ResolvedType resolvedType() {
	return ResolvedType.intType();
    }


    // Lowering operations

    /** Return the lowered version of this type */
    public ILType lower() {
	return ResolvedType.intType().lower();
    }
}
