/** The AST node for a VarDecl (which might be a class variable, a
 * local variable inside a method, or a formal parameter of a
 * method) */

package AST;

import SymbolTable.*;
import Helpers.*;

public class VarDecl extends ASTNode {
    // Instance variables

    // AST subtrees:
    public Type type;
    public String name;

    // Constructor
    public VarDecl(Type t, String n, int ln) {
	super(ln);
	type = t;
	name = n;
    }

    // AST printing
    public String toString(String indent) {
	return type.toString(indent) + " " + name;
    }
}
