/** The class for placeholder values for uninitialized variables. */

package Environment;

import Helpers.*;

public class UninitializedValue extends Value {
    // the single uninitialized value instance
    protected static UninitializedValue uninitializedValue = 
	new UninitializedValue();

    // Constructor (protected so that clients can't call it directly)
    protected UninitializedValue() { }

    // Public static operation to get the single uninitialized value
    // instance (this is what clients should call)
    public static UninitializedValue uninitializedValue() {
	return uninitializedValue;
    }

    // Printing operations
    public String toString() { 
	return "<uninitialized>";
    }

    // Evaluation operations

    /** Return whether the value is the special uninitialized value */
    public boolean isUninitialized() {
	return true;
    }
}
