/** This is the abstract superclass of all IL (intermediate language)
 * expressions that are direct or indirect function calls. */

package IL;

import Target.*;
import java.io.*;
import java.util.*;

public abstract class ILFunCallExpr extends ILExpr {
    // Instance variables
    protected ILType result_type;
    protected List/*<ILExpr>*/ args;


    // Constructor
    public ILFunCallExpr(ILType rt, List/*<ILExpr>*/ as) {
	result_type = rt;
	args = as;
    }


    // Printing
    public String toString() {
	String s = calleeToString() + "(";
	Iterator iter = args.iterator();
	boolean first = true;
	while (iter.hasNext()) {
	    ILExpr arg = (ILExpr)iter.next();
	    if (first) {
		first = false;
	    } else {
		s += ", ";
	    }
	    s += arg.toString();
	}
	s += "):" + result_type.toString();
	return s;
    }

    // return the string to use for the callee
    protected abstract String calleeToString();
}
