/** This is the class of IL (intermediate language) global data
 * initial values that are the addresses of global variables or
 * functions */

package IL;

import Target.*;
import java.io.*;

public class ILGlobalAddressValue extends ILValue {
    // Instance variable
    protected ILGlobalVar global_var;


    // Constructor
    public ILGlobalAddressValue(ILGlobalVar v) {
	global_var = v;
    }


    // Printing
    public String toString() {
	return "&" + global_var.toString();
    }


    // Target code generation operations

    /** generate code for this initializer */
    public void codegenInitializer(Target target) throws IOException {
	target.emitGlobalAddressInitializer(global_var.getName());
    }
}
