/** This is the class for references to IL (intermediate language)
 * global variables or functions.  Since we can create references to
 * global variables before they've been declared, e.g. for mutually
 * recursive functions & vtbls, then we just use a simple string name
 * for the variable, instead of its declaration. */

package IL;

public class ILGlobalVar {
    // Instance variable
    protected String name;

    // Constructor
    public ILGlobalVar(String n) {
	name = n;
    }

    // Accessor
    public String getName() {
	return name;
    }

    // Printing
    public String toString() {
	return name;
    }
}
