/** This is the class for IL (intermediate language) global variable
 * declarations. */

package IL;

import Target.*;
import java.io.*;

public class ILGlobalVarDecl {
    // Instance variables
    protected ILType type;
    protected String name;

    // Constructor
    public ILGlobalVarDecl(ILType t, String n) {
	type = t;
	name = n;
    }

    // Accessors
    public String getName() {
	return name;
    }

    public ILType getType() {
	return type;
    }

    // Printing
    public String toString() {
	return type.toString() + " " + name + ";";
    }


    // Target code generation operations

    /** generate code for this global variable declaration */
    public void codegen(Target target) throws IOException {
	target.emitUninitializedGlobalVarDecl(type, name);
    }
}
