/** This is the class for unconditional branch, i.e., goto, statements in
 * the IL (intermediate language) */

package IL;

import Target.*;
import java.io.*;

public class ILGotoStmt extends ILStmt {
    // Instance variable
    protected ILLabel target_label;


    // Constructor
    public ILGotoStmt(ILLabel tl) {
	target_label = tl;
    }


    // Printing
    public String toString() {
	return "goto " + target_label.toString() + ";";
    }


    // Target code generation operations

    /** generate target code for this statement */
    public void codegen(Target target) throws IOException {
	target.emitGoto(target_label);
    }
}
