/** This is the class of IL (intermediate language) record global data
 * initial values */

package IL;

import Target.*;
import java.io.*;
import java.util.*;

public class ILRecordValue extends ILValue {
    // Instance variable

    // the members of the record value
    protected List/*<ILRecordValueMember>*/ members;


    // Constructor
    public ILRecordValue(List/*<ILRecordValueMember>*/ ms) {
	members = ms;
    }


    // Printing operations

    // return a printable string representation of this value
    public String toString() { 
	String s = "{";
	Iterator iter = members.iterator();
	boolean first = true;
	while (iter.hasNext()) {
	    ILRecordValueMember member = (ILRecordValueMember)iter.next();
	    if (first) {
		first = false;
	    } else {
		s += ", ";
	    }
	    s += member.toString();
	}
	s += "}";
	return s;
    }


    // Target code generation operations

    /** generate code for this initializer */
    public void codegenInitializer(Target target) throws IOException {
	// generate initializers for each of the members, in sequence
	Iterator iter = members.iterator();
	boolean first = true;
	while (iter.hasNext()) {
	    ILRecordValueMember member = (ILRecordValueMember)iter.next();
	    // the alignment of the first field is OK, but the
	    // alignment of the later fields may need to be fixed up
	    member.codegenInitializer(target, first);
	    if (first) {
		first = false;
	    }
	}
    }
}
