/** This is the class for return statements in the IL (intermediate
 * language) */

package IL;

import Target.*;
import java.io.*;

public class ILReturnStmt extends ILStmt {
    // Instance variable
    protected ILExpr result;


    // Constructor
    public ILReturnStmt(ILExpr r) {
	result = r;
    }


    // Printing
    public String toString() {
	return "return " + result.toString() + ";";
    }


    // Target code generation operations

    /** generate target code for this statement */
    public void codegen(Target target) throws IOException {
	target.emitReturn(result);
    }
}
