/** This is the class for statements in the IL (intermediate language)
 * that throw exceptions, i.e., that report errors and end program
 * execution. */

package IL;

import Target.*;
import java.io.*;

public class ILThrowExceptionStmt extends ILStmt {
    // Instance variable
    protected String message;


    // Constructor
    public ILThrowExceptionStmt(String m) {
	message = m;
    }


    // Printing
    public String toString() {
	return "throw new Exception(\"" + message + "\");";
    }


    // Target code generation operations

    /** generate target code for this statement */
    public void codegen(Target target) throws IOException {
	target.emitThrowException(message);
    }
}
