/** This is the concrete class for registers on the MIPS target
 * machine. */

package Target.MIPS;

import Target.*;

public class MIPSRegister extends Location {
    /** The register number */
    int reg_num;

    /** Constructor */
    public MIPSRegister(int rn) {
	reg_num = rn; 
    }

    /** Return a printable representation of this location */
    public String toString() {
	return Integer.toString(reg_num);
    }

    /** Return the representation of this register used in output asm
     * code */
    public String codegenString() {
	return "$" + Integer.toString(reg_num);
    }	
}
